#include<stdio.h>
#include<stdlib.h>
#include<time.h>

#define LENGTH 100

void display_exception_message(int code)
{
    char exception_description[][LENGTH] = {
        "A file opening for writing exception.",
        "A file writing exception.",
        "A file closing exception.",
        "A file opening for appending exception.",
        "A file appending exception."
        "A file opening for reading exception."
    };
    fprintf(stderr,"%s\n",exception_description[-code-1]);
}

struct coordinates {
    double x,y,z;
};

int write_to_file(char *file_name)
{
    FILE *file = fopen(file_name,"w");
    if(file==NULL)
        return -1;
    int i;
    for(i=0; i<10; i++) {
        const int RANGE = 20;
        struct coordinates point;
        point.x = rand()%RANGE;
        point.y = rand()%RANGE;
        point.z = rand()%RANGE;
        if(fwrite(&point,sizeof(point),1,file)!=1)
            return -2;
    }
    if(fclose(file)!=0)
        return -3;
    return 0;
}

int add_to_file(char *file_name)
{
    FILE *file = fopen(file_name,"a");
    if(file==NULL)
        return -4;
    struct coordinates point;
    const int RANGE = 40;
    point.x = rand()%RANGE;
    point.y = rand()%RANGE;
    point.z = rand()%RANGE;
    if(fwrite(&point,sizeof(point),1,file)!=1)
        return -5;
    if(fclose(file)!=0)
        return -3;
    return 0;
}

int read_from_file(char *file_name)
{
    FILE *file = fopen(file_name,"r");
    if(file==NULL)
        return -6;
    int i=0;
    struct coordinates point;
    while(fread(&point,sizeof(point),1,file)==1)
        printf("Point %d -- x: %f, y: %f z: %f\n",++i,point.x, point.y, point.z);
    if(fclose(file)!=0)
        return -3;
    return 0;
}

int main(void)
{
    srand(time(0));
    int result = write_to_file("data.bin");
    if(result!=0)
        display_exception_message(result);
    result = add_to_file("data.bin");
    if(result!=0)
        display_exception_message(result);
    result = read_from_file("data.bin");
    if(result!=0)
        display_exception_message(result);
    return 0;
}
